<template>
    <q-page class="bg-bases">
        <DocumentWrapper ref="wrap">
            <template>

                <div v-if="workers.length === 0">
                    <AnimationComponent text="There are currently no workers. Create one?"
                                        :animation="$animations.emptyBox"
                                        :max-height="0.9"/>
                </div>
                <ListPage v-else>

                    <q-list separator class="col-lg-6 col-12" bordered>
                        <WorkerItem v-for="w in workers" :key="w.id" :worker="w"/>
                    </q-list>

                </ListPage>
            </template>
            <template #end>
                <q-btn round size='lg' color="accent" icon="add" class="q-ma-lg"
                       style="position: absolute; bottom: 0; right:0;"
                       :to='`/worker/create?sub=${routeParams.subId}`'>
                    <q-tooltip anchor="center left" self="center right">
                        Create a new Worker
                    </q-tooltip>
                </q-btn>
            </template>
        </DocumentWrapper>

    </q-page>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import AnimationComponent from "components/Core/AnimationComponent.vue";
import WorkerItem from "components/Entities/List/WorkerItem.vue";
import {WorkerPrincipalResponse} from "src/classLibrary/APIModels/core/workerPrincipalResponse";
import Container from "components/Core/Container.vue";
import ListPage from "components/Core/ListPage.vue";

@Component({
    components: {ListPage, Container, WorkerItem, AnimationComponent, DocumentWrapper}
})
export default class SubContractorWorkers extends Vue {
    workers: WorkerPrincipalResponse[] = [];

    routeParams = {
        subId: '',
    }


    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    async loadWorkers() {
        const p = this;
        const t = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<WorkerPrincipalResponse[]>(
            `Worker?projectId=${this.PersistentStore.StoreValue.project}&SubContractor=${this.routeParams.subId}`, null, t);

        r.match({
            err: (e) => p.Wrap.SubmitError(e),
            ok: (o) => {
                p.workers = o;
            }
        })

    }

    async mounted() {
        await this.loadWorkers();
    }
}
</script>
